#property copyright "Copyright  2013 Trading Attitude"
#property link      "http://www.trading-attitude.com"

/*

(CurrencyTrader de mai 2013)

Long entry (short exit):
1. Todays close is below its open (Close[0] < Open[0]).
2. Todays open is above the low two days ago (Open[0] > Low[2]).
3. Todays range is greater than the range seven days earlier (Range[0] > Range[7]).
4. Yesterdays close is above the close seven days ago (Close[1] > close[7]).
5. Yesterdays close is above the high four days ago (Close[1] > high[4]).
Short entry (long exit):
1. Todays close is above its open (Close[0] > Open[0]).
2. Todays open is below the high two days ago (Open[0] < High[2]).
3. Todays range is greater than the range seven days earlier (Range[0] > Range[7]).
4. Yesterdays close is below the close seven days ago (Close[1] < close[7]).
5. Yesterdays close is below the low four days ago (Close[1] < Low[4]).



   
   
iBarShift(NULL, 0, TimeCurrent()-(TimeCurrent()&3600)-(60 * 60 * (Hour()+1) ) )  // gives the bar number for 23:00 hour the previous day


TimeCurrent()-(TimeCurrent()&3600)-(60 * 60 * (Hour()+1) )       // gives the datetime for the 23:00 hour the previous day


*/
#define HR2400          86400                   // 24 * 3600

extern int MagicNumberBuy          = 45454;
extern int MagicNumberSell         = 45455;
extern double Lots       =0.01;

bool OpenBuy = false;
bool OpenSell = false;

double maVar = 2.0;
bool done = false;
datetime PrevBOD;
   
   
int init()
  {
   Print("Must be run in Daily timeframe");
   return(0);
  }
  
int start() {


   static datetime lastTradeOpen;
    datetime now = TimeCurrent(),
             BOD = DateOfDay(now);
    bool     isTradingAllowed = BOD != lastTradeOpen;
    
    datetime y2300 = BOD - 3600; // Yesterday+2300z
   int      i2300H1 = iBarShift(NULL, PERIOD_H1, y2300);
   datetime t2300   = iTime(0, PERIOD_H1, i2300H1);
   double   o2300   = iOpen(0, PERIOD_H1, i2300H1);
   //Print("Yesterday's open at ",TimeToStr(t2300), " was ", o2300);
   
   calculSignal();
   
   openOrder();
   
   PrevBOD = BOD;
   return(0);
}



void calculSignal() {
   static datetime lastTradeOpen;
    datetime now = TimeCurrent(),
             BOD = DateOfDay(now);
    bool     isTradingAllowed = BOD != lastTradeOpen;
    
    datetime y2300 = BOD - 3600; // Yesterday+2300z
   int      i2300H1 = iBarShift(NULL, PERIOD_H1, y2300);
   datetime t2300   = iTime(0, PERIOD_H1, i2300H1);
   double   o2300   = iOpen(0, PERIOD_H1, i2300H1);
   //Print("Yesterday's open at ",TimeToStr(t2300), " was ", o2300);
   
   
   if (PrevBOD == BOD) {
      return;
   }
   double pclose = iClose(Symbol(),PERIOD_D1,1);
   double popen = iOpen(Symbol(),PERIOD_D1,1);
   double phigh = iHigh(Symbol(),PERIOD_D1,1);
   double plow = iLow(Symbol(),PERIOD_D1,1);
   double p2low = iLow(Symbol(),PERIOD_D1,3);
   double p2high = iHigh(Symbol(),PERIOD_D1,3);
   double p7low = iLow(Symbol(),PERIOD_D1,8);
   double p7high = iHigh(Symbol(),PERIOD_D1,8);
   double p1close = iClose(Symbol(),PERIOD_D1,2);
   double p7close = iClose(Symbol(),PERIOD_D1,8);
   double p4high = iHigh(Symbol(),PERIOD_D1,5);
   double p4low = iLow(Symbol(),PERIOD_D1,3);

   bool crit1 = pclose < popen;
   bool crit2 = popen > p2low;
   double range = phigh - plow;
   double range7 = p7high - p7low;
   bool crit3 = range > range7;
   bool crit4 = p1close > p7close;
   bool crit5 = p1close > p4high;
   
   bool critBuy = crit1 && crit2 && crit3 && crit4 && crit5;
   
   if (critBuy) {
      OpenBuy = true;
   } else {
      OpenBuy = false;
   }
   
   crit1 = pclose > popen;
   crit2 = popen < p2high;
   crit3 = range > range7;
   crit4 = p1close < p7close;
   crit5 = p1close < p4low;
   
   bool critSell = crit1 && crit2 && crit3 && crit4 && crit5;
   
   if (critSell) {      
      OpenSell = true;
   } else {
      OpenSell = false;
   }
   
   
   openOrder();

}


void openOrder() {
   RefreshRates();
   double SL=0;
   double TP=0;
   double Ticket = 0;
   
   bool weAreLong = orderNumber(MagicNumberBuy) > 0;
   bool weAreShort = orderNumber(MagicNumberSell) > 0;
   bool notInMarket = !weAreLong && !weAreShort;
   
   if (OpenBuy && (weAreShort || notInMarket)) {
      if (weAreShort) {
         closeTrades(MagicNumberSell);
      }
      Ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,2,SL,TP,"Simple",MagicNumberBuy,0,Green);
      if (Ticket>=0) {
         OpenBuy = false;
      }
   } else if (OpenSell && (weAreLong || notInMarket)) {
      if (weAreLong) {
         closeTrades(MagicNumberBuy);
      }
      Ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,2,SL,TP,"Simple",MagicNumberSell,0,Green);
      if (Ticket>=0) {
         OpenSell = false;
      }
   }

}

void closeTrades(int mgNb) {
  int total = orderNumber(mgNb);
  for(int j=total-1;j>=0;j--) {
    OrderSelect(j, SELECT_BY_POS);
    int type   = OrderType();
   
   if (OrderMagicNumber() != mgNb) {
         continue;
   }
    bool result = false;
    
    switch(type) {
      //Close opened long positions
      case OP_BUY       : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
                          break;
      
      //Close opened short positions
      case OP_SELL      : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
                          
    }
  }
}


int orderNumber(int mgNb) {
   int total = 0;
   for(int i=1; i<=OrdersTotal(); i++) {         // Loop through orders
      if (OrderSelect(i-1,SELECT_BY_POS)==true) { 
         if (OrderSymbol()!=Symbol()) {
               continue;      // Another security
         }
         if (OrderMagicNumber() != mgNb) {
            continue;
         }
         
         total = total + 1;
      }
   }
   return (total);
}

datetime TimeOfDay(datetime when){  return( when % HR2400          );       }
datetime DateOfDay(datetime when){  return( when - TimeOfDay(when) );       }